<?php

namespace Teknisa\EST\Factories;

class Ger27000LocalDeEstoquePorProdutoFactory {
    protected $connection;

    public function __construct($entityManager) {
        $this->connection = $entityManager->getConnection();
    }

   public function getDadosProduto($params) {
        $sql = "SELECT P.NRORG,
                 P.CDNVPRODUTO,
                 F.CDFILIAL,
                 FF.NMFILIAL,
                 P.CDARVPROD,
                 P.CDPRODUTO,
                 P.NMPRODUTO,
                 F.CDALMOXARIFE,
                 A.DSALMOXARIFE DSALMOXARIFE,
                 F.CDALMOXQUAMPPIL,
                 X.DSALMOXARIFE DSALMOXQUAMPPIL,
                 F.CDLOCALQUAMPPIL,
                 R.DSLOCALESTOQ DSLOCALQUAMPPIL,
                 F.CDALMOXINSPRPIL,
                 Y.DSALMOXARIFE DSALMOXINSPRPIL,
                 F.CDLOCALINSPRPIL,
                 O.DSLOCALESTOQ DSLOCALINSPRPIL,
                 F.CDLOCALESTOQ,
                 E.DSLOCALESTOQ DSLOCALESTOQ,
                 F.CDALMOXPRACA,
                 C.DSALMOXARIFE DSALMOXPRACA,
                 F.CDLOCALPRACA,
                 G.DSLOCALESTOQ DSLOCALPRACA,
                 F.CDALMOXPRCLI,
                 D.DSALMOXARIFE DSALMOXPRCLI,
                 F.CDLOCALPRCLI,
                 H.DSLOCALESTOQ DSLOCALPRCLI,
                 F.CDALMOXINSPR,
                 I.DSALMOXARIFE DSALMOXINSPR,
                 F.CDLOCALINSPR,
                 J.DSLOCALESTOQ DSLOCALINSPR,
                 F.CDALMOXQUAR ,
                 Q.DSALMOXARIFE DSALMOXQUAR,
                 F.CDLOCALQUAR ,
                 L.DSLOCALESTOQ DSLOCALQUAR,
                 F.CDALMOXPRSEMACA,
                 M.DSALMOXARIFE DSALMOXPRSEMACA,
                 F.CDLOCALPRSEMACA,
                 N.DSLOCALESTOQ DSLOCALPRSEMACA,
                 F.CDALMOXPRODPL,
                 F.CDLOCPRODPL,
                 F.CDALMOXPROD,
                 F.CDLOCPROD,
                 AA.DSALMOXARIFE DSALPRODPIL,
                 BB.DSLOCALESTOQ DSLOCPRODPRIL,
                 CC.DSALMOXARIFE DSALPROD,
                 DD.DSLOCALESTOQ DSLOCPROD,
                 F.CDALMOXREPROV,
                 ARP.DSALMOXARIFE DSALMOXREPROV,
                 F.CDLOCALREPROV,
                 ALP.DSLOCALESTOQ AS DSLOCALREPROV,
                 F.CDALMOXCONSVND,
                 V.DSALMOXARIFE AS DSALMOXCONSVND,
                 F.CDLOCALCONSVND,
                 LV.DSLOCALESTOQ AS DSLOCALCONSVND
        FROM PRODFILI F, PRODUTO P, ALMOXARIFADO A, ALMOXARIFADO C, ALMOXARIFADO D, ALMOXARIFADO I, 
        LOCALESTOQUE E, ALMOXARIFADO M, LOCALESTOQUE G, LOCALESTOQUE H, LOCALESTOQUE J, ALMOXARIFADO Q, LOCALESTOQUE L, LOCALESTOQUE N, LOCALESTOQUE O, LOCALESTOQUE R , 
        ALMOXARIFADO X, ALMOXARIFADO Y, ALMOXARIFADO AA, 
        LOCALESTOQUE BB, ALMOXARIFADO CC, LOCALESTOQUE DD, 
        ALMOXARIFADO ARP,
        ALMOXARIFADO V, LOCALESTOQUE LV,
        LOCALESTOQUE ALP, 
        FILIAL FF WHERE(NVL(P.IDPRODATIVPR,'S') = 'S') AND(P.CDPRODUTO = F.CDPRODUTO(+)) AND(P.CDPRODUTO = :CDPRODUTO) AND(P.CDPRODUTO = P.CDPRODESTO)
                AND (F.CDFILIAL(+) = :CDFILIAL)
                AND (F.CDFILIAL = A.CDFILIAL (+))
                AND (F.CDALMOXARIFE = A.CDALMOXARIFE (+))
                AND (F.CDFILIAL = AA.CDFILIAL (+))
                AND (F.CDALMOXPRODPL = AA.CDALMOXARIFE (+))
                AND (F.CDFILIAL = BB.CDFILIAL (+))
                AND (F.CDALMOXPRODPL = BB.CDALMOXARIFE (+))
                AND (F.CDLOCPRODPL = BB.CDLOCALESTOQ (+))
                AND (F.CDFILIAL = CC.CDFILIAL (+))
                AND (F.CDALMOXPROD = CC.CDALMOXARIFE (+))
                AND (F.CDFILIAL = DD.CDFILIAL (+))
                AND (F.CDALMOXPROD = DD.CDALMOXARIFE (+))
                AND (F.CDLOCPROD = DD.CDLOCALESTOQ (+))
                AND (F.CDFILIAL = C.CDFILIAL (+))
                AND (F.CDALMOXPRACA = C.CDALMOXARIFE (+))
                AND (F.CDFILIAL = D.CDFILIAL (+))
                AND (F.CDALMOXPRCLI = D.CDALMOXARIFE (+))
                AND (F.CDFILIAL = E.CDFILIAL (+))
                AND (F.CDALMOXARIFE = E.CDALMOXARIFE (+))
                AND (F.CDLOCALESTOQ = E.CDLOCALESTOQ (+))
                AND (F.CDFILIAL = G.CDFILIAL (+))
                AND (F.CDALMOXPRACA = G.CDALMOXARIFE (+))
                AND (F.CDLOCALPRACA = G.CDLOCALESTOQ (+))
                AND (F.CDFILIAL = H.CDFILIAL (+))
                AND (F.CDALMOXPRCLI = H.CDALMOXARIFE (+))
                AND (F.CDLOCALPRCLI = H.CDLOCALESTOQ (+))
                AND (F.CDFILIAL = I.CDFILIAL (+))
                AND (F.CDALMOXINSPR = I.CDALMOXARIFE (+))
                AND (F.CDFILIAL = J.CDFILIAL (+))
                AND (F.CDALMOXINSPR = J.CDALMOXARIFE (+))
                AND (F.CDLOCALINSPR = J.CDLOCALESTOQ (+))
                AND (F.CDFILIAL = Q.CDFILIAL (+))
                AND (F.CDALMOXQUAR = Q.CDALMOXARIFE (+))
                AND (F.CDFILIAL = L.CDFILIAL (+))
                AND (F.CDALMOXQUAR = L.CDALMOXARIFE (+))
                AND (F.CDLOCALQUAR = L.CDLOCALESTOQ (+))
                AND (F.CDFILIAL = M.CDFILIAL (+))
                AND (F.CDALMOXPRSEMACA = M.CDALMOXARIFE (+))
                AND (F.CDFILIAL = N.CDFILIAL (+))
                AND (F.CDALMOXPRSEMACA = N.CDALMOXARIFE (+))
                AND (F.CDLOCALPRSEMACA = N.CDLOCALESTOQ (+))
                AND (F.CDFILIAL = R.CDFILIAL (+))
                AND (F.CDALMOXQUAMPPIL = R.CDALMOXARIFE (+))
                AND (F.CDLOCALQUAMPPIL = R.CDLOCALESTOQ (+))
                AND (F.CDFILIAL = O.CDFILIAL (+))
                AND (F.CDALMOXINSPRPIL = O.CDALMOXARIFE (+))
                AND (F.CDLOCALINSPRPIL = O.CDLOCALESTOQ (+))
                AND (F.CDFILIAL = X.CDFILIAL (+))
                AND (F.CDALMOXQUAMPPIL = X.CDALMOXARIFE (+))
                AND (F.CDFILIAL = Y.CDFILIAL (+))
                AND (F.CDALMOXINSPRPIL = Y.CDALMOXARIFE (+))
                AND (F.CDFILIAL = FF.CDFILIAL (+))
                AND (F.CDFILIAL = ARP.CDFILIAL(+))
                AND (F.CDALMOXREPROV = ARP.CDALMOXARIFE(+))
                AND (F.CDFILIAL = ALP.CDFILIAL (+))
                AND (F.CDALMOXREPROV = ALP.CDALMOXARIFE (+))
                AND (F.CDLOCALREPROV = ALP.CDLOCALESTOQ (+))
                AND (F.CDFILIAL = V.CDFILIAL (+))
                AND (F.CDALMOXCONSVND = V.CDALMOXARIFE (+))
                AND (F.CDFILIAL = LV.CDFILIAL (+))
                AND (F.CDALMOXCONSVND = LV.CDALMOXARIFE (+))
                AND (F.CDLOCALCONSVND =  LV.CDLOCALESTOQ (+))
        ORDER BY  P.CDARVPROD";

        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getProdutos($params) {
        $sql = "SELECT PF.CDFILIAL,
                 P.CDARVPROD,
                 P.CDPRODUTO,
                 P.NMPRODUTO,
                 P.SGUNIDADE,
                 P.CDNVPRODUTO,
                 P.CDPRODNIVANTE,
                 P.NRORG,
                
            CASE
            WHEN S.CDPRODNIVANTE IS NOT NULL THEN
            'true'
            ELSE 'false'
            END PAI
        FROM PRODUTO P LEFT JOIN
            (SELECT DISTINCT CDPRODNIVANTE,
                 NRORG
            FROM PRODUTO) S
            ON P.CDARVPROD = S.CDPRODNIVANTE
                AND P.NRORG = S.NRORG
        JOIN PRODFILI PF
            ON P.CDPRODUTO = PF.CDPRODUTO
                AND PF.CDFILIAL = :CDFILIAL
                AND P.CDNVPRODUTO = :CDNVPRODUTO
                AND (P.CDARVPROD
            BETWEEN :P_CDPRODINI
                AND :P_CDPRODFIN||'zzzzzzzzzzzzzzzzzzzz'
                OR :TODOS = 'T')
        ORDER BY  P.CDNVPRODUTO, P.CDARVPROD";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
        
    }
}