package com.javaseleniumtemplate.tests;
import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.pages.LoginPage;
import com.javaseleniumtemplate.pages.MainPage;
import org.testng.Assert;
import org.testng.annotations.Test;

public class LoginTests extends TestBase {
    //Objects
    LoginPage loginPage;
    MainPage mainPage;

    //Tests
    @Test( description = "Est-01")
    public void efetuarLoginComSucesso() {
        //Objects instances
        loginPage = new LoginPage();
        mainPage = new MainPage();

        //Parameteres
        String usuario = "deivison";
        String senha = "1";
        String mensagemMainPage = "BRASIL";

        //Test
        loginPage.preenhcerUsuario(usuario);
        loginPage.preencherSenha(senha);
        loginPage.clicarEmLogin();
        loginPage.aceitarMensagemAlerta();

        Assert.assertTrue(mainPage.retornaUsernameDasInformacoesDeLogin().contains(mensagemMainPage));
    }
}


